/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsStudyRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsStudy extends TableImpl<VIsStudyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_study</code>
     */
    public static final VIsStudy V_IS_STUDY = new VIsStudy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsStudyRecord> getRecordType() {
        return VIsStudyRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_study.key_element</code>.
     */
    public final TableField<VIsStudyRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_study.dn</code>.
     */
    public final TableField<VIsStudyRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private VIsStudy(Name alias, Table<VIsStudyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsStudy(Name alias, Table<VIsStudyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_is_study" as  SELECT t_core_element_hierarchy.key_element,
         t_core_element_hierarchy.dn
        FROM (common_dd.t_core_element_hierarchy
          RIGHT JOIN common_dd.t_core_study ON ((t_core_study.fk_element = t_core_element_hierarchy.key_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_study</code> table reference
     */
    public VIsStudy(String alias) {
        this(DSL.name(alias), V_IS_STUDY);
    }

    /**
     * Create an aliased <code>common_dd.v_is_study</code> table reference
     */
    public VIsStudy(Name alias) {
        this(alias, V_IS_STUDY);
    }

    /**
     * Create a <code>common_dd.v_is_study</code> table reference
     */
    public VIsStudy() {
        this(DSL.name("v_is_study"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsStudy as(String alias) {
        return new VIsStudy(DSL.name(alias), this);
    }

    @Override
    public VIsStudy as(Name alias) {
        return new VIsStudy(alias, this);
    }

    @Override
    public VIsStudy as(Table<?> alias) {
        return new VIsStudy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsStudy rename(String name) {
        return new VIsStudy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsStudy rename(Name name) {
        return new VIsStudy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsStudy rename(Table<?> name) {
        return new VIsStudy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudy where(Condition condition) {
        return new VIsStudy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
